From 887616c1c4f27e617fa306a7ae48251756cd7abf Mon Sep 17 00:00:00 2001
From: Ralph Bean <rbean@redhat.com>
Date: Jun 04 2015 16:49:15 +0000
Subject: [PATCH 47/254] Merge pull request #3 from ralphbean/feature/invalidation


Take a stab at cache invalidation.
---

diff --git a/.gitignore b/.gitignore
index 0d20b64..e6e04af 100644
--- a/.gitignore
+++ b/.gitignore
@@ -1 +1,2 @@
 *.pyc
+*.egg*
diff --git a/fedmsg.d/testconfig.py b/fedmsg.d/testconfig.py
index a405684..6bfeb35 100644
--- a/fedmsg.d/testconfig.py
+++ b/fedmsg.d/testconfig.py
@@ -1,4 +1,21 @@
 config = {
+
+    'hubs.consumer.enabled': True,
+    # Production ready.
+    'hubs.sqlalchemy.uri': 'sqlite:////var/tmp/hubs.db',
+
     'endpoints': {
+        # TODO -- fill these out later...
     },
+
+    'logging': dict(
+        version=1,
+        loggers=dict(
+            hubs={
+                "level": "DEBUG",
+                "propagate": False,
+                "handlers": ["console"],
+            },
+        ),
+    ),
 }
diff --git a/hubs/app.py b/hubs/app.py
index c7432c4..f1fa7b7 100644
--- a/hubs/app.py
+++ b/hubs/app.py
@@ -17,6 +17,9 @@ app.config.from_object('hubs.default_config')
 if 'HUBS_CONFIG' in os.environ:
     app.config.from_envvar('HUBS_CONFIG')
 
+import fedmsg.config
+fedmsg_config = fedmsg.config.load_config()
+
 
 @app.route('/')
 def index():
@@ -26,7 +29,7 @@ def index():
 @app.route('/<name>')
 @app.route('/<name>/')
 def hub(name):
-    session = models.init(app.config['DB_URL'])
+    session = models.init(fedmsg_config['hubs.sqlalchemy.uri'])
     hub = session.query(models.Hub)\
         .filter(models.Hub.name==name)\
         .first()
@@ -60,7 +63,7 @@ def get_widget(session, hub, idx):
 @app.route('/<hub>/<idx>')
 @app.route('/<hub>/<idx>/')
 def widget_render(hub, idx):
-    session = models.init(app.config['DB_URL'])
+    session = models.init(fedmsg_config['hubs.sqlalchemy.uri'])
     widget = get_widget(session, hub, idx)
 
     # Make this artificially slow for development...
@@ -69,17 +72,17 @@ def widget_render(hub, idx):
     print(widget.plugin, "sleeping artificially for", s)
     time.sleep(s)
 
-    return widget.render(flask.request, session)
+    return widget.render(session)
 
 
 @app.route('/<hub>/<idx>/json')
 @app.route('/<hub>/<idx>/json/')
 def widget_json(hub, idx):
-    session = models.init(app.config['DB_URL'])
+    session = models.init(fedmsg_config['hubs.sqlalchemy.uri'])
     widget = get_widget(session, hub, idx)
     from hubs.widgets import registry
     module = registry[widget.plugin]
-    data = module.data(flask.request, session, widget, **widget.config)
+    data = module.data(session, widget, **widget.config)
     response = flask.jsonify(data)
 
     # We don't actually need these two headers.  Just messing around.
diff --git a/hubs/consumer.py b/hubs/consumer.py
new file mode 100644
index 0000000..08d1eca
--- /dev/null
+++ b/hubs/consumer.py
@@ -0,0 +1,82 @@
+# The fedora hubs backend daemon
+
+import time
+import random
+
+import fedmsg.consumers
+
+import hubs.models
+
+from hubs.widgets.base import invalidate_cache
+
+import logging
+log = logging.getLogger("hubs")
+
+
+class CacheInvalidatorExtraordinaire(fedmsg.consumers.FedmsgConsumer):
+    topic = '*'
+    config_key = 'hubs.consumer.enabled'
+
+    def __init__(self, *args, **kwargs):
+        log.info("CacheInvalidatorExtraordinaire initializing")
+        super(CacheInvalidatorExtraordinaire, self).__init__(*args, **kwargs)
+
+        self.uri = self.hub.config.get('hubs.sqlalchemy.uri', None)
+        self.junk_suffixes = self.hub.config.get('hubs.junk_suffixes', [])
+
+        if not self.uri:
+            raise ValueError('hubs.sqlalchemy.uri must be present')
+
+        log.info("CacheInvalidatorExtraordinaire initialized")
+
+    def make_session(self):
+        return hubs.models.init(self.uri)
+
+    def consume(self, raw_msg):
+        session = self.make_session()
+        try:
+            self.work(session, raw_msg)
+            session.commit()  # transaction is committed here
+        except:
+            session.rollback()  # rolls back the transaction
+            raise
+
+    def work(self, session, raw_msg):
+        topic, msg = raw_msg['topic'], raw_msg['body']
+
+        for suffix in self.junk_suffixes:
+            if topic.endswith(suffix):
+                log.info("Dropping %r", topic)
+                return
+
+        start = time.time()
+        log.info("CacheInvalidatorExtraordinaire received %s %s",
+                  msg['msg_id'], msg['topic'])
+
+        # Begin our real work.
+        # Find which widgets should have their caches nuked and make it so.
+
+        # First, make a thread-local copy of the widgets.
+        widgets = list(session.query(hubs.models.Widget).all())
+        log.info("Comparing message against %i widgets" % len(widgets))
+
+        # Shuffle it so that not all threads step through the list in the same
+        # order.  This should cut down on competition for the dogpile lock.
+        random.shuffle(widgets)
+
+        # And do the real work of comparing every widget against the message.
+        for widget in widgets:
+            if widget.module.should_invalidate(msg, session, widget):
+                log.info("Invalidating cache for %r" % widget)
+                # Invalidate the cache...
+                invalidate_cache(widget.module, **widget.config)
+                # Rebuild it.
+                widget.module.data(session, widget, **widget.config)
+                # TODO -- fire off an EventSource notice that we updated stuff
+
+        log.info("Done.  %0.2fs %s %s",
+                  time.time() - start, msg['msg_id'], msg['topic'])
+
+    def stop(self):
+        log.info("Cleaning up CacheInvalidatorExtraordinaire.")
+        super(CacheInvalidatorExtraordinaire, self).stop()
diff --git a/hubs/models.py b/hubs/models.py
index 6d328de..49eb665 100644
--- a/hubs/models.py
+++ b/hubs/models.py
@@ -146,10 +146,13 @@ class Widget(BASE):
             'plugin': self.plugin,
         }
 
-    def render(self, request, session):
-        module = hubs.widgets.registry[self.plugin]
+    @property
+    def module(self):
+        return hubs.widgets.registry[self.plugin]
+
+    def render(self, session):
         render = hubs.widgets.render
-        return render(module, request, session, self, **self.config)
+        return render(self.module, session, self, **self.config)
 
 
 class User(BASE):
diff --git a/hubs/widgets/__init__.py b/hubs/widgets/__init__.py
index 832c936..4078e33 100644
--- a/hubs/widgets/__init__.py
+++ b/hubs/widgets/__init__.py
@@ -59,13 +59,13 @@ def prepare_registry(registry):
 validate_registry(registry)
 prepare_registry(registry)
 
-def render(module, request, session, widget, *args, **kwargs):
+def render(module, session, widget, *args, **kwargs):
     """ Main API entry point.
 
     Call this to render a widget into HTML
     """
     # The API returns exactly this data.  Shared cache
-    data = module.data(request, session, widget, *args, **kwargs)
+    data = module.data(session, widget, *args, **kwargs)
 
     # Use the API data to fill out a template, and potentially decorate it.
     return module.render(**data)
diff --git a/hubs/widgets/base.py b/hubs/widgets/base.py
index 9bfe26e..e0d1581 100644
--- a/hubs/widgets/base.py
+++ b/hubs/widgets/base.py
@@ -51,15 +51,20 @@ def AGPLv3(name):
 def smartcache(module):
     def decorator(func):
         @wraps(func)
-        def inner(request, session, widget, *args, **kwargs):
+        def inner(session, widget, *args, **kwargs):
             key = cache_key_generator(module, args, kwargs)
-            creator = lambda: func(request, session, widget, *args, **kwargs)
+            creator = lambda: func(session, widget, *args, **kwargs)
             return cache.get_or_create(key, creator)
 
         return inner
     return decorator
 
 
+def invalidate_cache(module, *args, **kwargs):
+    key = cache_key_generator(module, *args, **kwargs)
+    cache.delete(key)
+
+
 def cache_key_generator(module, args, kwargs):
     return "|".join([
         module.__name__,
diff --git a/hubs/widgets/dummy.py b/hubs/widgets/dummy.py
index fb44797..d0c9e57 100644
--- a/hubs/widgets/dummy.py
+++ b/hubs/widgets/dummy.py
@@ -12,5 +12,13 @@ chrome = panel("This is a dummy widget")
 @argument(name="text", default="Lorem ipsum dolor...",
           validator=validators.text,
           help="Some dummy text to display.")
-def data(request, session, widget, text):
+def data(session, widget, text):
     return dict(text=text)
+
+
+def should_invalidate(message, session, widget):
+    if not message['topic'].endswith('hubs.widget.update'):
+        return False
+    if message['msg']['widget']['id'] != widget.id:
+        return False
+    return True
diff --git a/hubs/widgets/rules.py b/hubs/widgets/rules.py
index 2a6a632..3e0fb4d 100644
--- a/hubs/widgets/rules.py
+++ b/hubs/widgets/rules.py
@@ -39,7 +39,19 @@ template = jinja2.Template("""
 @argument(name='link', default=None,
           validator=validators.link,
           help="Link to the community rules and guidelines")
-def data(request, session, widget, link):
+def data(session, widget, link):
     owners = widget.hub.owners
     owners = ordereddict([(o, avatar(o)) for o in owners])
     return dict(owners=owners, link=link)
+
+
+def should_invalidate(message, session, widget):
+    if message['topic'].endswith('hubs.widget.update'):
+        if message['msg']['widget']['id'] == widget.id:
+            return True
+
+    if message['topic'].endswith('hubs.hub.update'):
+        if message['msg']['hub']['name'] == widget.hub.name:
+            return True
+
+    return False
diff --git a/hubs/widgets/stats.py b/hubs/widgets/stats.py
index a181453..1e14658 100644
--- a/hubs/widgets/stats.py
+++ b/hubs/widgets/stats.py
@@ -31,8 +31,18 @@ template = jinja2.Template("""
 """)
 
 
-def data(request, session, widget):
+def data(session, widget):
     return dict(
         members=len(widget.hub.members),
         subscribers=len(widget.hub.subscribers),
     )
+
+
+def should_invalidate(message, session, widget):
+    if message['topic'].endswith('hubs.hub.update'):
+        if message['msg']['hub']['name'] == widget.hub.name:
+            return True
+
+    # TODO -- also check for FAS group changes??  are we doing that?
+
+    return False
diff --git a/hubs/widgets/sticky.py b/hubs/widgets/sticky.py
index 60da776..36d4a1a 100644
--- a/hubs/widgets/sticky.py
+++ b/hubs/widgets/sticky.py
@@ -12,6 +12,14 @@ chrome = panel(title='Sticky Note', klass="panel-info")
 @argument(name="text", default="Lorem ipsum dolor...",
           validator=validators.text,
           help="Some dummy text to display.")
-def data(request, session, widget, text):
+def data(session, widget, text):
     # TODO -- render with markdown
     return dict(text=text)
+
+
+def should_invalidate(message, session, widget):
+    if message['topic'].endswith('hubs.widget.update'):
+        if message['msg']['widget']['id'] == widget.id:
+            return True
+
+    return False
diff --git a/populate.py b/populate.py
index 2c44efc..8751dc6 100755
--- a/populate.py
+++ b/populate.py
@@ -2,18 +2,13 @@
 """ Populate the hubs db with some dev data. """
 
 import json
-import os
-
-import flask
 
 import hubs.models
 
-app = flask.Flask(__name__)
-app.config.from_object('hubs.default_config')
-if 'HUBS_CONFIG' in os.environ:
-    app.config.from_envvar('HUBS_CONFIG')
+import fedmsg.config
+fedmsg_config = fedmsg.config.load_config()
 
-session = hubs.models.init(app.config['DB_URL'], True, True)
+session = hubs.models.init(fedmsg_config['hubs.sqlalchemy.uri'], True, True)
 
 hub = hubs.models.Hub(name='designteam', summary='The Fedora Design Team')
 session.add(hub)
diff --git a/setup.py b/setup.py
new file mode 100644
index 0000000..5a66e3e
--- /dev/null
+++ b/setup.py
@@ -0,0 +1,43 @@
+""" Setup file for fedora hubs """
+
+from setuptools import setup, find_packages
+
+
+def get_description():
+    with open('README.rst', 'r') as f:
+        return ''.join(f.readlines()[2:])
+
+
+def get_requirements():
+    with open('requirements.txt', 'r') as f:
+        return [l.strip() for l in f.readlines() if l.strip()]
+
+
+setup(
+    name='fedora-hubs',
+    version='0.0.1',
+    description='A community portal for fedora contributors and you!',
+    long_description=get_description(),
+    author='Ralph Bean',
+    author_email='rbean@redhat.com',
+    url="https://github.com/ralphbean/fedora-hubs-prototype",
+    download_url="https://pypi.python.org/pypi/fedora-hubs/",
+    license='AGPLv3+',
+    install_requires=get_requirements(),
+    #tests_require=tests_require,
+    #test_suite='nose.collector',
+    packages=find_packages(),
+    include_package_data=True,
+    zip_safe=False,
+    classifiers=[
+        'Environment :: Web Environment',
+        'Topic :: Software Development :: Libraries :: Python Modules',
+        'Intended Audience :: Developers',
+        'Programming Language :: Python',
+    ],
+    entry_points={
+        'moksha.consumer': [
+            "cache_invalidator = hubs.consumer:CacheInvalidatorExtraordinaire",
+        ],
+    },
+)

